/*
ATmega1280专用功能函数库；通过arduino配置，用户不需要自行配置
*/
#define PORTX	PORTA 
#define DDRX 	DDRA

#define RS 	38
#define WR 	39
#define CS 	40
#define RST 41

#define T_CLK 	6
#define T_CS 	5
#define T_DIN 	4
#define T_DOUT 	3
#define T_IRQ 	2

#define PE0_H	PORTE |= 0X01;
#define PE0_L	PORTE &= ~0X01;
#define PE1_H	PORTE |= 0X02;
#define PE1_L	PORTE &= ~0X02;
#define PE4_H	PORTE |= 0X10;
#define PE4_L	PORTE &= ~0X10;
#define PE5_H	PORTE |= 0X20;
#define PE5_L	PORTE &= ~0X20;
#define PG5_H	PORTG |= 0X20;
#define PG5_L	PORTG &= ~0X20;
#define PE3_H	PORTE |= 0X08;
#define PE3_L	PORTE &= ~0X08;
#define PH3_H	PORTH |= 0X08;
#define PH3_L	PORTH &= ~0X08;
#define PH4_H	PORTH |= 0X10;
#define PH4_L	PORTH &= ~0X10;
#define CS_H	PORTF |= 0X08;
#define CS_L	PORTF &= ~0X08;
#define WR_H	PORTF |= 0X10;
#define WR_L	PORTF &= ~0X10;
#define RS_H	PORTF |= 0X20;
#define RS_L	PORTF &= ~0X20;

#define T_DIN_H    PORTF |= 0X01;
#define T_DIN_L    PORTF &= ~0X01;
#define T_CLK_H    PORTF |= 0X02;
#define T_CLK_L    PORTF &= ~0X02;
#define T_DOUT_H   PORTH |= 0X20;
#define T_DOUT_L   PORTH &= ~0X20;
#define T_IRQ_H    PORTH |= 0X40;
#define T_IRQ_L    PORTH &= ~0X40;

	
void LCDTouch::_hw_special_init()
{
}

void LCDTouch::LCD_Writ_Bus(char VH,char VL, byte mode)
{   
	switch (mode)
	{
	case 1:
		if (display_serial_mode==SERIAL_4PIN)
		{
			if (VH==1)
				sbi(P_SDA, B_SDA);
			else
				cbi(P_SDA, B_SDA);
			
		pulse_low(P_SCL, B_SCL);
		}
		else
		{
		if (VH==1)
			sbi(P_RS, B_RS);
		else
			cbi(P_RS, B_RS);
		}

		if (VL & 0x80)
			sbi(P_SDA, B_SDA);
		else
			cbi(P_SDA, B_SDA);
		pulse_low(P_SCL, B_SCL);
		if (VL & 0x40)
			sbi(P_SDA, B_SDA);
		else
			cbi(P_SDA, B_SDA);
		pulse_low(P_SCL, B_SCL);
		if (VL & 0x20)
			sbi(P_SDA, B_SDA);
		else
			cbi(P_SDA, B_SDA);
		pulse_low(P_SCL, B_SCL);
		if (VL & 0x10)
			sbi(P_SDA, B_SDA);
		else
			cbi(P_SDA, B_SDA);
		pulse_low(P_SCL, B_SCL);
		if (VL & 0x08)
			sbi(P_SDA, B_SDA);
		else
			cbi(P_SDA, B_SDA);
		pulse_low(P_SCL, B_SCL);
		if (VL & 0x04)
			sbi(P_SDA, B_SDA);
		else
			cbi(P_SDA, B_SDA);
		pulse_low(P_SCL, B_SCL);
		if (VL & 0x02)
			sbi(P_SDA, B_SDA);
		else
			cbi(P_SDA, B_SDA);
		pulse_low(P_SCL, B_SCL);
		if (VL & 0x01)
			sbi(P_SDA, B_SDA);
		else
			cbi(P_SDA, B_SDA);
		pulse_low(P_SCL, B_SCL);
		break;
	case 8:
#if defined(USE_UNO_SHIELD_ON_MEGA)
		PORTG &= ~0x20;
		PORTG |= (VH & 0x10)<<1;
		PORTH &= ~0x18;
		PORTH |= (VH & 0xC0)>>3;
		PORTE &= ~0x3B;
		PORTE |= (VH & 0x03) + ((VH & 0x0C)<<2) + ((VH & 0x20)>>2);
		pulse_low(P_WR, B_WR);
		PORTG &= ~0x20;
		PORTG |= (VL & 0x10)<<1;
		PORTH &= ~0x18;
		PORTH |= (VL & 0xC0)>>3;
		PORTE &= ~0x3B;
		PORTE |= (VL & 0x03) + ((VL & 0x0C)<<2) + ((VL & 0x20)>>2);
		pulse_low(P_WR, B_WR);
#else
		PORTA = VH;
		pulse_low(P_WR, B_WR);
		PORTA = VL;
		pulse_low(P_WR, B_WR);
#endif
		break;
	case 16:
		PORTA = VH;
		PORTC = VL;
		pulse_low(P_WR, B_WR);
		break;
	case LATCHED_16:
		PORTG &= ~0x20;	
		PORTG |= (VH & 0x10)<<1;	
		PORTH &= ~0x18;	
		PORTH |= (VH & 0xC0)>>3;	
		PORTE &= ~0x3B;	
		PORTE |= (VH & 0x03) + ((VH & 0x0C)<<2) + ((VH & 0x20)>>2);
		cbi(P_ALE, B_ALE);
		pulse_high(P_ALE, B_ALE);
		cbi(P_CS, B_CS);
		PORTG &= ~0x20;	
		PORTG |= (VL & 0x10)<<1;	
		PORTH &= ~0x18;	
		PORTH |= (VL & 0xC0)>>3;	
		PORTE &= ~0x3B;	
		PORTE |= (VL & 0x03) + ((VL & 0x0C)<<2) + ((VL & 0x20)>>2);
		pulse_low(P_WR, B_WR);
		sbi(P_CS, B_CS);
		break;
	}
}

void LCDTouch::_set_direction_registers(byte mode)
{
#if defined(USE_UNO_SHIELD_ON_MEGA)
	DDRH = 0x18;
	DDRG = 0x20;
	DDRE = 0x3B;
#else
	if (mode!=LATCHED_16)
	{
		DDRA = 0xFF;
		if (mode==16)
			DDRC = 0xFF;
	}
	else
	{
		DDRH = 0x18;
		DDRG = 0x20;
		DDRE = 0x3B;
	}
#endif
}

void LCDTouch::_fast_fill_16(int ch, int cl, long pix)
{
#if defined(USE_UNO_SHIELD_ON_MEGA)
	if (ch==cl)
		_fast_fill_8(ch, pix);
	else
	{
		for (int i=0; i<pix; i++)
		{
			PORTG &= ~0x20;
			PORTG |= (ch & 0x10)<<1;
			PORTH &= ~0x18;
			PORTH |= (ch & 0xC0)>>3;
			PORTE &= ~0x3B;
			PORTE |= (ch & 0x03) + ((ch & 0x0C)<<2) + ((ch & 0x20)>>2);
			pulse_low(P_WR, B_WR);
			PORTG &= ~0x20;
			PORTG |= (cl & 0x10)<<1;
			PORTH &= ~0x18;
			PORTH |= (cl & 0xC0)>>3;
			PORTE &= ~0x3B;
			PORTE |= (cl & 0x03) + ((cl & 0x0C)<<2) + ((cl & 0x20)>>2);
			pulse_low(P_WR, B_WR);
		}
	}
#else
	long blocks;

	PORTA = ch;
	PORTC = cl;

	blocks = pix/16;
	for (int i=0; i<blocks; i++)
	{
		pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);
	}
	if ((pix % 16) != 0)
		for (int i=0; i<(pix % 16); i++)
		{
			pulse_low(P_WR, B_WR);
		}
#endif
}

void LCDTouch::_fast_fill_8(int ch, long pix)
{
	long blocks;

#if defined(USE_UNO_SHIELD_ON_MEGA)
	PORTG &= ~0x20;
	PORTG |= (ch & 0x10)<<1;
	PORTH &= ~0x18;
	PORTH |= (ch & 0xC0)>>3;
	PORTE &= ~0x3B;
	PORTE |= (ch & 0x03) + ((ch & 0x0C)<<2) + ((ch & 0x20)>>2);
#else
	PORTA = ch;
#endif

	blocks = pix/16;
	for (int i=0; i<blocks; i++)
	{
		pulse_low(P_WR, B_WR);pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);pulse_low(P_WR, B_WR);
	}
	if ((pix % 16) != 0)
		for (int i=0; i<(pix % 16); i++)
		{
			pulse_low(P_WR, B_WR);
			pulse_low(P_WR, B_WR);
		}
}
void LCDTouch::LCDUTFT(byte model)
{ 
	orient=LANDSCAPE;
	
	switch (model)
	{
		case LCD2_4:
			disp_x_size=240;
			disp_y_size=320;
			display_transfer_mode=8;
		break;
		case LCD2_8:
			disp_x_size = 240;
			disp_y_size = 320;
			display_transfer_mode=8;
		break;
		case LCD3_2:
			disp_x_size=240;
			disp_y_size=320;
			display_transfer_mode=16;
			break;
		
	}
	display_model=model;	
	fch=0xff;
	fcl=0xff;
	bch=0x00;
	bcl=0x00;
	if (display_transfer_mode!=1)
	{
		_set_direction_registers(display_transfer_mode);
	}
	
		P_RS = portOutputRegister(digitalPinToPort(RS));
		B_RS = digitalPinToBitMask(RS);
		P_WR = portOutputRegister(digitalPinToPort(WR));
		B_WR = digitalPinToBitMask(WR);
		P_CS = portOutputRegister(digitalPinToPort(CS));
		B_CS = digitalPinToBitMask(CS);
		P_RST = portOutputRegister(digitalPinToPort(RST));
		B_RST = digitalPinToBitMask(RST);

		//pinMode(RS,OUTPUT);
		//DDRD |= 0X80;
		//pinMode(WR,OUTPUT);
		//DDRG |= 0X04;
		//pinMode(CS,OUTPUT);
		//DDRG |= 0X02;
		//pinMode(RST,OUTPUT);
		//DDRG |= 0X01;
}
void LCDTouch::Write_Command(unsigned int c)
{
	if(display_model == LCD2_4 || display_model == LCD2_8)
	{
		//digitalWrite(RS,LOW);
		RS_L;
		//digitalWrite(CS,LOW);	
		CS_L;
		if(c>>8&0x01)
		{
			PE0_H;
		}
		else
		{	
			PE0_L;
		}
		if(c>>8&0x02)
		{
			PE1_H;
		}
		else
		{
			PE1_L;
		}
		if(c>>8&0x04)
		{
			PE4_H;
		}
		else
		{
			PE4_L;
		}
		if(c>>8&0x08)
		{	
			PE5_H;
		}
		else
		{
			PE5_L;
		}
		if(c>>8&0x10)
		{
			PG5_H;
		}
		else
		{
			PG5_L;
		}
		if(c>>8&0x20)
		{
			PE3_H;
		}
		else
		{
			PE3_L;
		}
		if(c>>8&0x40)
		{
			PH3_H;
		}
		else
		{
			PH3_L;
		}
		if(c>>8&0x80)
		{
			PH4_H;
		}
		else
		{
			PH4_L;
		}

		//digitalWrite(WR,LOW);
		WR_L;
		//digitalWrite(WR,HIGH);	
		WR_H;
		if(c&0x01)
		{
			PE0_H;
		}
		else
		{
			PE0_L;
		}
		if(c&0x02)
		{
			PE1_H;
		}
		else
		{
			PE1_L;
		}
		if(c&0x04)
		{
			PE4_H;
		}
		else
		{
			PE4_L;
		}
		if(c&0x08)
		{	
			PE5_H;
		}
		else
		{
			PE5_L;
		}
		if(c&0x10)
		{
			PG5_H;
		}
		else
		{
			PG5_L;
		}
		if(c&0x20)
		{
			PE3_H;
		}
		else
		{
			PE3_L;
		}
		if(c&0x40)
		{
			PH3_H;
		}
		else
		{
			PH3_L;
		}
		if(c&0x80)
		{
			PH4_H;
		}
		else
		{
			PH4_L;
		}		
		//digitalWrite(WR,LOW);
		WR_L;
		//digitalWrite(WR,HIGH);
		WR_H;
		//digitalWrite(CS,HIGH);
		CS_H;
		   
	}
	else 
	{

			//digitalWrite(CS,LOW);
			PORTG &= 0XFD;
			//digitalWrite(RS,LOW);
			PORTD &= 0X7F;
			
			PORTX = c >> 8;
			PORTC = c;
			//digitalWrite(WR,LOW);
			PORTG &= 0XFB;
			//digitalWrite(WR,HIGH);
			PORTG |= 0X04;
			//digitalWrite(CS,HIGH);
			PORTG |= 0X02;
	}
}
void LCDTouch::Write_Data(unsigned int c)
{
	if(display_model == LCD2_4 || display_model == LCD2_8)
	{

				//digitalWrite(RS,HIGH);
				RS_H;
				//digitalWrite(CS,LOW); 
				CS_L;
				if(c>>8&0x01)
				{
					PE0_H;
				}
				else
				{
					PE0_L;
				}
				if(c>>8&0x02)
				{
					PE1_H;
				}
				else
				{
					PE1_L;
				}
				if(c>>8&0x04)
				{
					PE4_H;
				}
				else
				{
					PE4_L;
				}
				if(c>>8&0x08)
				{
					PE5_H;
				}
				else
				{
					PE5_L;
				}
				if(c>>8&0x10)
				{
					PG5_H;
				}
				else
				{
					PG5_L;
				}
				if(c>>8&0x20)
				{
					PE3_H;
				}
				else
				{
					PE3_L;
				}
				if(c>>8&0x40)
				{
					PH3_H;
				}
				else
				{
					PH3_L;
				}
				if(c>>8&0x80)
				{
					PH4_H;
				}
				else
				{
					PH4_L;
				}
				//	digitalWrite(WR,LOW);
				WR_L;
				//digitalWrite(WR,HIGH);
				WR_H;
				if(c&0x01)
				{
					PE0_H;
				}
				else
				{
					PE0_L;
				}
				if(c&0x02)
				{
					PE1_H;
				}
				else
				{
					PE1_L;
				}
				if(c&0x04)
				{
					PE4_H;
				}
				else
				{
					PE4_L;
				}
				if(c&0x08)
				{
					PE5_H;
				}
				else
				{
					PE5_L;
				}
				if(c&0x10)
				{
					PG5_H;
				}
				else
				{
					PG5_L;
				}
				if(c&0x20)
				{
					PE3_H;
				}
				else
				{
					PE3_L;
				}
				if(c&0x40)
				{
					PH3_H;
				}
				else
				{
					PH3_L;
				}
				if(c&0x80)
				{
					PH4_H;
				}
				else
				{
					PH4_L;
				}		
			//digitalWrite(WR,LOW);
			WR_L;
			//digitalWrite(WR,HIGH);
			WR_H;
			//digitalWrite(CS,HIGH);
			CS_H;
		
	}
	else 
	{
			//digitalWrite(CS,LOW);
			PORTG &= 0XFD;
			//digitalWrite(RS,HIGH);
			PORTD |= 0X80;
			PORTX = c >> 8;
			PORTC = c;
			//digitalWrite(WR,LOW);
			PORTG &= 0XFB;
			//digitalWrite(WR,HIGH);
			PORTG |= 0X04;
			//digitalWrite(CS,HIGH);
			PORTG |= 0X02;
		
	}
}
void LCDTouch::LCD_Write_DATA(char VH,char VL)
{
	if (display_transfer_mode!=1)
	{
		sbi(P_RS, B_RS);
		LCD_Writ_Bus(VH,VL,display_transfer_mode);
	}
	else
	{
		LCD_Writ_Bus(0x01,VH,display_transfer_mode);
		LCD_Writ_Bus(0x01,VL,display_transfer_mode);
	}
}
void LCDTouch::Write_Command_Data(unsigned int cmd,unsigned int dat)
{
	Write_Command(cmd);
	Write_Data(dat);
}

void LCDTouch::Lcd_Init()
{
	if(display_model == LCD2_4)
	{	
		DDRF |= 0X3F;
		//DDRF |= (1<<3)|(1<<4)|(1<<2);
		DDRE |= 0X3B;
		//DDRH |= (1<<3)|(1<<2);
		DDRH |= 0X18;
		//DDRG |= (1<<4);
		DDRG |= 0X20;
		
		delay(1);	
		delay(1);
		CS_H;
		WR_H;		
		delay(20);
		
	Write_Command_Data(0x0011,0x2004);		
    Write_Command_Data(0x0013,0xCC00);		
    Write_Command_Data(0x0015,0x2600);	
	Write_Command_Data(0x0014,0x252A);	
//	Write_Command_Data(0x14,0x002A);		
	Write_Command_Data(0x0012,0x0033);		
	Write_Command_Data(0x0013,0xCC04);		
	//delayms(1); 
	Write_Command_Data(0x0013,0xCC06);		
	//delayms(1); 
	Write_Command_Data(0x0013,0xCC4F);		
	//delayms(1); 
	Write_Command_Data(0x0013,0x674F);
	Write_Command_Data(0x0011,0x2003);
	//delayms(1); 	
	Write_Command_Data(0x0030,0x2609);		
	Write_Command_Data(0x0031,0x242C);		
	Write_Command_Data(0x0032,0x1F23);		
	Write_Command_Data(0x0033,0x2425);		
	Write_Command_Data(0x0034,0x2226);		
	Write_Command_Data(0x0035,0x2523);		
	Write_Command_Data(0x0036,0x1C1A);		
	Write_Command_Data(0x0037,0x131D);		
	Write_Command_Data(0x0038,0x0B11);		
	Write_Command_Data(0x0039,0x1210);		
	Write_Command_Data(0x003A,0x1315);		
	Write_Command_Data(0x003B,0x3619);		
	Write_Command_Data(0x003C,0x0D00);		
	Write_Command_Data(0x003D,0x000D);		
	Write_Command_Data(0x0016,0x0007);		
	Write_Command_Data(0x0002,0x0013);		
	Write_Command_Data(0x0003,0x0003);		
	Write_Command_Data(0x0001,0x0127);		
	//delayms(1); 
	Write_Command_Data(0x0008,0x0303);		
	Write_Command_Data(0x000A,0x000B);		
	Write_Command_Data(0x000B,0x0003);   
	Write_Command_Data(0x000C,0x0000);   
	Write_Command_Data(0x0041,0x0000);    
	Write_Command_Data(0x0050,0x0000);   
	Write_Command_Data(0x0060,0x0005);    
    Write_Command_Data(0x0070,0x000B);    
	Write_Command_Data(0x0071,0x0000);    
	Write_Command_Data(0x0078,0x0000);    
	Write_Command_Data(0x007A,0x0000);   
	Write_Command_Data(0x0079,0x0007);		
	Write_Command_Data(0x0007,0x0051);   
	//delayms(1); 	
	Write_Command_Data(0x0007,0x0053);		
	Write_Command_Data(0x0079,0x0000);

	Write_Command(0x0022);
	}
	else if(display_model == LCD2_8)
	{	
		DDRF |= 0X3F;
		//DDRF |= (1<<3)|(1<<4)|(1<<2);
		DDRE |= 0X3B;
		//DDRH |= (1<<3)|(1<<2);
		DDRH |= 0X18;
		//DDRG |= (1<<4);
		DDRG |= 0X20;
		
		delay(1);	
		delay(1);
		CS_H;
		WR_H;		
		delay(20);
	
	Write_Command_Data(0x00E5, 0x78F0); // set SRAM internal timing
	Write_Command_Data(0x0001, 0x0100); // set Driver Output Control  
	Write_Command_Data(0x0002, 0x0200); // set 1 line inversion  
	Write_Command_Data(0x0003, 0x1030); // set GRAM write direction and BGR=1.  
	Write_Command_Data(0x0004, 0x0000); // Resize register  
	Write_Command_Data(0x0008, 0x0207); // set the back porch and front porch  
	Write_Command_Data(0x0009, 0x0000); // set non-display area refresh cycle ISC[3:0]  
	Write_Command_Data(0x000A, 0x0000); // FMARK function  
	Write_Command_Data(0x000C, 0x0000); // RGB interface setting  
	Write_Command_Data(0x000D, 0x0000); // Frame marker Position  
	Write_Command_Data(0x000F, 0x0000); // RGB interface polarity  
	//*************Power 00On sequence ****************//  
	Write_Command_Data(0x0010, 0x0000); // SAP, BT[3:0], AP, DSTB, SLP, STB  
	Write_Command_Data(0x0011, 0x0007); // DC1[2:0], DC0[2:0], VC[2:0]  
	Write_Command_Data(0x0012, 0x0000); // VREG1OUT voltage  
	Write_Command_Data(0x0013, 0x0000); // VDV[4:0] for VCOM amplitude  
	Write_Command_Data(0x0007, 0x0001);  
	delay(200); // Dis-ch00arge capacitor power voltage  
	Write_Command_Data(0x0010, 0x1690); // SAP, BT[3:0], AP, DSTB, SLP, STB  
	Write_Command_Data(0x0011, 0x0227); // Set DC1[2:0], DC0[2:0], VC[2:0]  
	delay(50); // Delay 5000ms  
	Write_Command_Data(0x0012, 0x000D); // 0012  
	delay(50); // Delay 5000ms  
	Write_Command_Data(0x0013, 0x1200); // VDV[4:0] for VCOM amplitude  
	Write_Command_Data(0x0029, 0x000A); // 04  VCM[5:0] for VCOMH  
	Write_Command_Data(0x002B, 0x000D); // Set Frame Rate  
	delay(50); // Delay 5000ms  
	Write_Command_Data(0x0020, 0x0000); // GRAM horizontal Address  
	Write_Command_Data(0x0021, 0x0000); // GRAM Vertical Address  
	// ----------- Adjust00 the Gamma Curve ----------//  
	Write_Command_Data(0x0030, 0x0000);  
	Write_Command_Data(0x0031, 0x0404);  
	Write_Command_Data(0x0032, 0x0003);  
	Write_Command_Data(0x0035, 0x0405);  
	Write_Command_Data(0x0036, 0x0808);  
	Write_Command_Data(0x0037, 0x0407);  
	Write_Command_Data(0x0038, 0x0303);  
	Write_Command_Data(0x0039, 0x0707);  
	Write_Command_Data(0x003C, 0x0504);  
	Write_Command_Data(0x003D, 0x0808);  
	//------------------ 00Set GRAM area ---------------//  
	Write_Command_Data(0x0050, 0x0000); // Horizontal GRAM Start Address  
	Write_Command_Data(0x0051, 0x00EF); // Horizontal GRAM End Address  
	Write_Command_Data(0x0052, 0x0000); // Vertical GRAM Start Address  
	Write_Command_Data(0x0053, 0x013F); // Vertical GRAM Start Address  
	Write_Command_Data(0x0060, 0xA700); // Gate Scan Line  
	Write_Command_Data(0x0061, 0x0001); // NDL,VLE, REV   
	Write_Command_Data(0x006A, 0x0000); // set scrolling line  
	//-------------- Part00ial Display Control ---------//  
	Write_Command_Data(0x0080, 0x0000);  
	Write_Command_Data(0x0081, 0x0000);  
	Write_Command_Data(0x0082, 0x0000);  
	Write_Command_Data(0x0083, 0x0000);  
	Write_Command_Data(0x0084, 0x0000);  
	Write_Command_Data(0x0085, 0x0000);  
	//-------------- Pane00l Control -------------------//  
	Write_Command_Data(0x0090, 0x0010);  
	Write_Command_Data(0x0092, 0x0000);  
	Write_Command_Data(0x0007, 0x0133);
	}	
	else
	{
		DDRD |= 0X80;
		DDRG |= 0X04;
		DDRG |= 0X02;
		DDRG |= 0X01;
		
		
		DDRX = 0xff;
		DDRC = 0xff;
		PORTG |= 0X01;
		delay(1);	
		PORTG &= 0XFE;
		delay(1);
		
		PORTG |= 0X01;
		PORTG |= 0X02;
		PORTG |= 0X04;
		delay(20);
		
		Write_Command_Data(0x0000,0x0001);
		Write_Command_Data(0x0003,0xA8A4);
		Write_Command_Data(0x000C,0x0000);
		Write_Command_Data(0x000D,0x080C);
		Write_Command_Data(0x000E,0x2B00);
		Write_Command_Data(0x001E,0x00B7);
		Write_Command_Data(0x0001,0x2B3F);
		Write_Command_Data(0x0002,0x0600);
		Write_Command_Data(0x0010,0x0000);
		Write_Command_Data(0x0011,0x6070);
		Write_Command_Data(0x0005,0x0000);
		Write_Command_Data(0x0006,0x0000);
		Write_Command_Data(0x0016,0xEF1C);
		Write_Command_Data(0x0017,0x0003);
		Write_Command_Data(0x0007,0x0233);
		Write_Command_Data(0x000B,0x0000);
		Write_Command_Data(0x000F,0x0000);
		Write_Command_Data(0x0041,0x0000);
		Write_Command_Data(0x0042,0x0000);
		Write_Command_Data(0x0048,0x0000);
		Write_Command_Data(0x0049,0x013F);
		Write_Command_Data(0x004A,0x0000);
		Write_Command_Data(0x004B,0x0000);
		Write_Command_Data(0x0044,0xEF00);
		Write_Command_Data(0x0045,0x0000);
		Write_Command_Data(0x0046,0x013F);
		Write_Command_Data(0x0030,0x0707);
		Write_Command_Data(0x0031,0x0204);
		Write_Command_Data(0x0032,0x0204);
		Write_Command_Data(0x0033,0x0502);
		Write_Command_Data(0x0034,0x0507);
		Write_Command_Data(0x0035,0x0204);
		Write_Command_Data(0x0036,0x0204);
		Write_Command_Data(0x0037,0x0502);
		Write_Command_Data(0x003A,0x0302);
		Write_Command_Data(0x003B,0x0302);
		Write_Command_Data(0x0023,0x0000);
		Write_Command_Data(0x0024,0x0000);
		Write_Command_Data(0x0025,0x8000);
		Write_Command_Data(0x004f,0x0000);
		Write_Command_Data(0x004e,0x0000);
		Write_Command(0x0022);
	}	
}

void LCDTouch::Touch_Init(void)
{
	orient					= LANDSCAPE;
	_default_orientation	= CAL_S>>31;
	touch_x_left			= (CAL_X>>14) & 0x3FFF;
	touch_x_right			= CAL_X & 0x3FFF;
	touch_y_top				= (CAL_Y>>14) & 0x3FFF;
	touch_y_bottom			= CAL_Y & 0x3FFF;
	disp_x_size				= (CAL_S>>12) & 0x0FFF;
	disp_y_size				= CAL_S & 0x0FFF;
	prec					= 10;
	
	if(display_model == LCD2_4||display_model == LCD2_8)
	{
		DDRF |= 0X03;
		DDRH &= ~0X20;
		DDRH &= ~0X40;

		T_CLK_H;
		T_DIN_H;
		T_CLK_H;
	}
	else
	{
		pinMode(T_CLK,  OUTPUT);
		pinMode(T_CS,   OUTPUT);
		pinMode(T_DIN,  OUTPUT);
		pinMode(T_DOUT, INPUT);
		pinMode(T_IRQ,  INPUT);
	
		digitalWrite(T_CS,  HIGH);
		digitalWrite(T_CLK, HIGH);
		digitalWrite(T_DIN, HIGH);
		digitalWrite(T_CLK, HIGH);
	}
}

void LCDTouch::Touch_WriteData(unsigned char data)
{
	unsigned char temp;
	unsigned char nop;
	unsigned char count;
	
	if(display_model == LCD2_4||display_model == LCD2_8)
	{
		temp=data;
		T_CLK_L;
		
		for(count=0; count<8; count++)
		{
			if(temp & 0x80)
			{
				T_DIN_H;
			}
			else
			{	
				T_DIN_L;
			}
			
				temp = temp << 1; 
				T_CLK_L;
				nop++;
				T_CLK_H;
				nop++;
		}
	}
	else 
	{
		temp=data;
		digitalWrite(T_CLK,LOW);
		
		for(count=0; count<8; count++)
		{
			if(temp & 0x80)
			{
				digitalWrite(T_DIN, HIGH);
			}
			else
			{	
				digitalWrite(T_DIN, LOW);
			}
			
			temp = temp << 1; 
			digitalWrite(T_CLK, LOW);
			nop++;
			digitalWrite(T_CLK, HIGH);
			nop++;
		}
	}
}
unsigned int LCDTouch::Touch_ReadData()
{
	unsigned char nop;
	unsigned int data = 0;
	unsigned char count;
	if(display_model == LCD2_4||display_model == LCD2_8)
	{
		for(count=0; count<12; count++)
		{
			data <<= 1;
			T_CLK_H;
			nop++;
			T_CLK_L;
			nop++;
			
			if(PINH & 0X20)	
			{
				data++;
			}
		}
	}
	else 
	{
		for(count=0; count<12; count++)
		{
			data <<= 1;
			digitalWrite(T_CLK, HIGH);
			nop++;
			digitalWrite(T_CLK, LOW);
			nop++;
			if (digitalRead(T_DOUT))	
			{
				data++;
			}
		}
	}
	return(data);
}
void LCDTouch::Touch_Read()
{
	unsigned long tx=0, temp_x=0;
	unsigned long ty=0, temp_y=0;
	int datacount=0;
	
	if(display_model == LCD2_4||display_model == LCD2_8)
	{
		for (int i=0; i<prec; i++)
		{
			Touch_WriteData(0x90);        
			T_CLK_H; 
			T_CLK_L;
			temp_x=Touch_ReadData();
			Touch_WriteData(0xD0);    
			T_CLK_H;
			T_CLK_L;
			temp_y=Touch_ReadData();
			if (!((temp_x>max(touch_x_left, touch_x_right)) or (temp_x==0) or (temp_y>max(touch_y_top, touch_y_bottom)) or (temp_y==0)))
			{
				ty+=temp_x;
				tx+=temp_y;
				datacount++;
			}
		}
	}
else
{
	digitalWrite(T_CS,LOW); 
	
	for (int i=0; i<prec; i++)
	{
		Touch_WriteData(0x90);        
		digitalWrite(T_CLK,HIGH);
		digitalWrite(T_CLK,LOW); 
		temp_x=Touch_ReadData();
		Touch_WriteData(0xD0);      
		digitalWrite(T_CLK,HIGH);
		digitalWrite(T_CLK,LOW);
		temp_y=Touch_ReadData();
		if (!((temp_x>max(touch_x_left, touch_x_right)) or (temp_x==0) or (temp_y>max(touch_y_top, touch_y_bottom)) or (temp_y==0)))
		{
			ty+=temp_x;
			tx+=temp_y;
			datacount++;
		}
	}

	digitalWrite(T_CS,HIGH);
}
	if (datacount>0)
	{
		if (orient == _default_orientation)
		{
			TP_X=tx/datacount;
			TP_Y=ty/datacount;
		}
		else
		{
			TP_X=ty/datacount;
			TP_Y=tx/datacount;
		}
	}
	else
	{
		TP_X=-1;
		TP_Y=-1;
	}
	
}

char LCDTouch::Touch_DataAvailable()
{
  char avail;
  if(display_model == LCD2_4||display_model == LCD2_8)
	{
		DDRH &= ~0X40;
		avail = !(PINH & 0X40);
		DDRH |= 0X40;
	}
	else
	{
	pinMode(T_IRQ,  INPUT);
	avail = !digitalRead(T_IRQ);
	pinMode(T_IRQ,  OUTPUT);
	}
  return avail;
}
int LCDTouch::Touch_GetX()
{
	long c;

	if (orient == _default_orientation)
	{
		c = long(long(TP_X - touch_x_left) * (disp_x_size)) / long(touch_x_right - touch_x_left);
		//if (c<0)
		//	c = 0;
		//if (c>disp_x_size)
		//	c = disp_x_size;
	}
	else
	{
		if (_default_orientation == PORTRAIT)
			c = long(long(TP_X - touch_y_top) * (-disp_y_size)) / long(touch_y_bottom - touch_y_top) + long(disp_y_size);
		else
			c = long(long(TP_X - touch_y_top) * (disp_y_size)) / long(touch_y_bottom - touch_y_top);
		//if (c<0)
		//	c = 0;
		//if (c>disp_y_size)
		//	c = disp_y_size;
	}
	if(display_model == LCD2_4)
	{
		c += 14;
		c = 320/150*c;
	}
	else if(display_model == LCD2_8)	
	{
		c = 320/145*c;
	}
	else
	{
		c = c;
	}
	return c;
}
int LCDTouch::Touch_GetY()
{
	int c;

	if (orient == _default_orientation)
	{
		c = long(long(TP_Y - touch_y_top) * (disp_y_size)) / long(touch_y_bottom - touch_y_top);
		//if (c<0)
		//	c = 0;
		//if (c>disp_y_size)
		//	c = disp_y_size;
	}
	else
	{
		if (_default_orientation == PORTRAIT)
			c = long(long(TP_Y - touch_x_left) * (disp_x_size)) / long(touch_x_right - touch_x_left);
		else
			c = long(long(TP_Y - touch_x_left) * (-disp_x_size)) / long(touch_x_right - touch_x_left) + long(disp_x_size);
		//if (c<0)
		//	c = 0;
		//if (c>disp_x_size)
		//	c = disp_x_size;
	}
	
	if(display_model == LCD2_4)
	{
		//c += 10;
		c = 240/92*c;
	}
	else if(display_model == LCD2_8)
	{
		c =(240-240/110*c);
	}
	else
	{
		c = c;
	}
	
	return c;
}

