/*
ATmega328专用功能函数库；通过arduino配置，用户不需要自行配置
*/
#define RS 	19
#define WR 	18
#define CS 	17
#define RST 16

#define T_CLK 	15
#define T_CS 	20
#define T_DIN 	14
#define T_DOUT 	8
#define T_IRQ 	9

#define RS_L	PORTC &= ~0X20
#define RS_H 	PORTC |= 0X20
#define WR_L	PORTC &= ~0X10	
#define WR_H	PORTC |= 0X10
#define CS_L	PORTC &= ~0X08
#define CS_H	PORTC |= 0X08
#define RST_L	PORTC &= ~0X04
#define RST_H	PORTC |= 0X04

void LCDTouch::_hw_special_init()
{
}

void LCDTouch::LCD_Writ_Bus(char VH,char VL, byte mode)
{   
	switch (mode)
	{
	case 1:
		if (display_serial_mode==SERIAL_4PIN)
		{
		if (VH==1)
			sbi(P_SDA, B_SDA);
		else
			cbi(P_SDA, B_SDA);
		pulse_low(P_SCL, B_SCL);
		}
		else
		{
		if (VH==1)
			sbi(P_RS, B_RS);
		else
			cbi(P_RS, B_RS);
		}

		if (VL & 0x80)
			sbi(P_SDA, B_SDA);
		else
			cbi(P_SDA, B_SDA);
		pulse_low(P_SCL, B_SCL);
		if (VL & 0x40)
			sbi(P_SDA, B_SDA);
		else
			cbi(P_SDA, B_SDA);
		pulse_low(P_SCL, B_SCL);
		if (VL & 0x20)
			sbi(P_SDA, B_SDA);
		else
			cbi(P_SDA, B_SDA);
		pulse_low(P_SCL, B_SCL);
		if (VL & 0x10)
			sbi(P_SDA, B_SDA);
		else
			cbi(P_SDA, B_SDA);
		pulse_low(P_SCL, B_SCL);
		if (VL & 0x08)
			sbi(P_SDA, B_SDA);
		else
			cbi(P_SDA, B_SDA);
		pulse_low(P_SCL, B_SCL);
		if (VL & 0x04)
			sbi(P_SDA, B_SDA);
		else
			cbi(P_SDA, B_SDA);
		pulse_low(P_SCL, B_SCL);
		if (VL & 0x02)
			sbi(P_SDA, B_SDA);
		else
			cbi(P_SDA, B_SDA);
		pulse_low(P_SCL, B_SCL);
		if (VL & 0x01)
			sbi(P_SDA, B_SDA);
		else
			cbi(P_SDA, B_SDA);
		pulse_low(P_SCL, B_SCL);
		break;
	case 8:
		cport(PORTC, 0xBF);
		cport(PORTD, 0x60);
		PORTC += ((VH & 0x20)<<1);
		PORTD += ((VH & 0x40)<<1) + (VH & 0x10) + ((VH & 0x08)>>3) + ((VH & 0x04)>>1) + ((VH & 0x03)<<2);
		pulse_low(P_WR, B_WR);

		cport(PORTC, 0xBF);
		cport(PORTD, 0x60);
		PORTC += ((VL & 0x20)<<1);
		PORTD += ((VL & 0x40)<<1) + (VL & 0x10) + ((VL & 0x08)>>3) + ((VL & 0x04)>>1) + ((VL & 0x03)<<2);
		pulse_low(P_WR, B_WR);
		break;
	case 16:
		cport(PORTB, 0x0F);
		cport(PORTC, 0x3F);
		cport(PORTD, 0x20);

		PORTB |= ((VL & 0x0F)<<4);
		PORTC |= ((VL & 0x20)<<2) + ((VH & 0x20)<<1);
		PORTD |= ((VH & 0x40)<<1) + (VH & 0x10) + ((VH & 0x08)>>3) + ((VH & 0x04)>>1) + ((VH & 0x03)<<2) + ((VL & 0x10)<<2);

		pulse_low(P_WR, B_WR);
		break;
	case LATCHED_16:
		cport(PORTC, 0xBF);
		cport(PORTD, 0x60);
		PORTC += ((VH & 0x20)<<1);
		PORTD += ((VH & 0x40)<<1) + (VH & 0x10) + ((VH & 0x08)>>3) + ((VH & 0x04)>>1) + ((VH & 0x03)<<2);
		cbi(P_ALE, B_ALE);
		pulse_high(P_ALE, B_ALE);
		cbi(P_CS, B_CS);
		cport(PORTC, 0xBF);
		cport(PORTD, 0x60);
		PORTC += ((VL & 0x20)<<1);
		PORTD += ((VL & 0x40)<<1) + (VL & 0x10) + ((VL & 0x08)>>3) + ((VL & 0x04)>>1) + ((VL & 0x03)<<2);
		pulse_low(P_WR, B_WR);
		sbi(P_CS, B_CS);
		break;
	}
}

void LCDTouch::_set_direction_registers(byte mode)
{
	switch (mode)
	{
	case 8:
	case LATCHED_16:
		DDRC |= 0x40;
		DDRD |= 0x9F;
		break;
	case 16:
		DDRB |= 0xF0;
		DDRC |= 0xC0;
		DDRD |= 0xDF;
		break;
	}
}

void LCDTouch::_fast_fill_16(int ch, int cl, long pix)
{
	long blocks;

	cport(PORTB, 0x0F);
	cport(PORTC, 0x3F);
	cport(PORTD, 0x20);


	PORTB |= ((cl & 0x0F)<<4);
	PORTC |= ((cl & 0x20)<<2) + ((ch & 0x20)<<1);
	PORTD |= ((ch & 0x40)<<1) + (ch & 0x10) + ((ch & 0x08)>>3) + ((ch & 0x04)>>1) + ((ch & 0x03)<<2) + ((cl & 0x10)<<2);


	blocks = pix/16;
	for (int i=0; i<blocks; i++)
	{
		pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);
	}
	if ((pix % 16) != 0)
		for (int i=0; i<(pix % 16); i++)
		{
			pulse_low(P_WR, B_WR);
		}
}

void LCDTouch::_fast_fill_8(int ch, long pix)
{
	long blocks;

	cport(PORTC, 0xBF);
	cport(PORTD, 0x60);

	PORTC |= ((ch & 0x20)<<1);
	PORTD |= ((ch & 0x40)<<1) + (ch & 0x10) + ((ch & 0x08)>>3) + ((ch & 0x04)>>1) + ((ch & 0x03)<<2);

	blocks = pix/16;
	for (int i=0; i<blocks; i++)
	{
		pulse_low(P_WR, B_WR);pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);pulse_low(P_WR, B_WR);
		pulse_low(P_WR, B_WR);pulse_low(P_WR, B_WR);
	}
	if ((pix % 16) != 0)
		for (int i=0; i<(pix % 16); i++)
		{
			pulse_low(P_WR, B_WR);pulse_low(P_WR, B_WR);
		}
}
void LCDTouch::LCDUTFT(byte model)
{ 
	switch (model)
	{
	case LCD2_4:
		disp_x_size=240;
		disp_y_size=320;
		display_transfer_mode=8;
	break;
	case LCD2_8:
		disp_x_size=240;
		disp_y_size=320;
		display_transfer_mode=8;
	break;
	case LCD3_2:
			
	break;	
	}
	
	orient=LANDSCAPE;
	
	display_model=model;
	
	fch=0xff;
	fcl=0xff;
	bch=0x00;
	bcl=0x00;
	
	if (display_transfer_mode!=1)
	{
		_set_direction_registers(display_transfer_mode);
	}
	
	P_RS = portOutputRegister(digitalPinToPort(RS));
	B_RS = digitalPinToBitMask(RS);
	P_WR = portOutputRegister(digitalPinToPort(WR));
	B_WR = digitalPinToBitMask(WR);
	P_CS = portOutputRegister(digitalPinToPort(CS));
	B_CS = digitalPinToBitMask(CS);
	P_RST = portOutputRegister(digitalPinToPort(RST));
	B_RST = digitalPinToBitMask(RST);
				
}
void LCDTouch::Write_Command(unsigned int c)
{
	
		//digitalWrite(RS,LOW);
		RS_L;
		//digitalWrite(CS,LOW);	 
		CS_L;
		
		PORTD = c>>8; 
		
		//digitalWrite(WR,LOW);
		WR_L;
		//digitalWrite(WR,HIGH);	
		WR_H;
		
		PORTD = c;		
		
		//digitalWrite(WR,LOW);
		WR_L;
		//digitalWrite(WR,HIGH);
		WR_H;
		//digitalWrite(CS,HIGH);
		CS_H;
 
}
void LCDTouch::Write_Data(unsigned int c)
{
		// digitalWrite(RS,HIGH);
		RS_H;
		//digitalWrite(CS,LOW);	 
		CS_L;
		
		PORTD = c>>8; 
		//digitalWrite(WR,LOW);
		WR_L;
		//digitalWrite(WR,HIGH);
		WR_H;
		
		PORTD = c;		
	
		//digitalWrite(WR,LOW);
		WR_L;
		//digitalWrite(WR,HIGH);
		WR_H;
		//digitalWrite(CS,HIGH);
		CS_H;		

}
void LCDTouch::LCD_Write_DATA(char VH,char VL)
{
	if (display_transfer_mode!=1)
	{
		sbi(P_RS, B_RS);
		LCD_Writ_Bus(VH,VL,display_transfer_mode);
	}
	else
	{
		LCD_Writ_Bus(0x01,VH,display_transfer_mode);
		LCD_Writ_Bus(0x01,VL,display_transfer_mode);
	}
}
void LCDTouch::Write_Command_Data(unsigned int cmd,unsigned int dat)
{
	Write_Command(cmd);
	Write_Data(dat);
}

void LCDTouch::Lcd_Init()
{

		//pinMode(RS,OUTPUT);
		DDRC |= 0X3C;
		DDRD = 0xFF;

		//digitalWrite(RST,HIGH);
		RST_H;
		delay(1);	
		//digitalWrite(RST,LOW);
		RST_L;
		delay(1);

		//digitalWrite(RST,HIGH);
		RST_H;
		//digitalWrite(CS,HIGH);
		CS_H;
		//digitalWrite(WR,HIGH);
		WR_H;
		delay(20);	
		
	if(display_model == LCD2_4)
	{	
	Write_Command_Data(0x0011,0x2004);		
    Write_Command_Data(0x0013,0xCC00);		
    Write_Command_Data(0x0015,0x2600);	
	Write_Command_Data(0x0014,0x252A);	
//	Write_Command_Data(0x14,0x002A);		
	Write_Command_Data(0x0012,0x0033);		
	Write_Command_Data(0x0013,0xCC04);		
	//delayms(1); 
	Write_Command_Data(0x0013,0xCC06);		
	//delayms(1); 
	Write_Command_Data(0x0013,0xCC4F);		
	//delayms(1); 
	Write_Command_Data(0x0013,0x674F);
	Write_Command_Data(0x0011,0x2003);
	//delayms(1); 	
	Write_Command_Data(0x0030,0x2609);		
	Write_Command_Data(0x0031,0x242C);		
	Write_Command_Data(0x0032,0x1F23);		
	Write_Command_Data(0x0033,0x2425);		
	Write_Command_Data(0x0034,0x2226);		
	Write_Command_Data(0x0035,0x2523);		
	Write_Command_Data(0x0036,0x1C1A);		
	Write_Command_Data(0x0037,0x131D);		
	Write_Command_Data(0x0038,0x0B11);		
	Write_Command_Data(0x0039,0x1210);		
	Write_Command_Data(0x003A,0x1315);		
	Write_Command_Data(0x003B,0x3619);		
	Write_Command_Data(0x003C,0x0D00);		
	Write_Command_Data(0x003D,0x000D);		
	Write_Command_Data(0x0016,0x0007);		
	Write_Command_Data(0x0002,0x0013);		
	Write_Command_Data(0x0003,0x0003);		
	Write_Command_Data(0x0001,0x0127);		
	//delayms(1); 
	Write_Command_Data(0x0008,0x0303);		
	Write_Command_Data(0x000A,0x000B);		
	Write_Command_Data(0x000B,0x0003);   
	Write_Command_Data(0x000C,0x0000);   
	Write_Command_Data(0x0041,0x0000);    
	Write_Command_Data(0x0050,0x0000);   
	Write_Command_Data(0x0060,0x0005);    
    Write_Command_Data(0x0070,0x000B);    
	Write_Command_Data(0x0071,0x0000);    
	Write_Command_Data(0x0078,0x0000);    
	Write_Command_Data(0x007A,0x0000);   
	Write_Command_Data(0x0079,0x0007);		
	Write_Command_Data(0x0007,0x0051);   
	//delayms(1); 	
	Write_Command_Data(0x0007,0x0053);		
	Write_Command_Data(0x0079,0x0000);

	Write_Command(0x0022);
	
	}
	else
	{
	Write_Command_Data(0x00E5, 0x78F0); // set SRAM internal timing
	Write_Command_Data(0x0001, 0x0100); // set Driver Output Control  
	Write_Command_Data(0x0002, 0x0200); // set 1 line inversion  
	Write_Command_Data(0x0003, 0x1030); // set GRAM write direction and BGR=1.  
	Write_Command_Data(0x0004, 0x0000); // Resize register  
	Write_Command_Data(0x0008, 0x0207); // set the back porch and front porch  
	Write_Command_Data(0x0009, 0x0000); // set non-display area refresh cycle ISC[3:0]  
	Write_Command_Data(0x000A, 0x0000); // FMARK function  
	Write_Command_Data(0x000C, 0x0000); // RGB interface setting  
	Write_Command_Data(0x000D, 0x0000); // Frame marker Position  
	Write_Command_Data(0x000F, 0x0000); // RGB interface polarity  
	//*************Power 00On sequence ****************//  
	Write_Command_Data(0x0010, 0x0000); // SAP, BT[3:0], AP, DSTB, SLP, STB  
	Write_Command_Data(0x0011, 0x0007); // DC1[2:0], DC0[2:0], VC[2:0]  
	Write_Command_Data(0x0012, 0x0000); // VREG1OUT voltage  
	Write_Command_Data(0x0013, 0x0000); // VDV[4:0] for VCOM amplitude  
	Write_Command_Data(0x0007, 0x0001);  
	delay(200); // Dis-ch00arge capacitor power voltage  
	Write_Command_Data(0x0010, 0x1690); // SAP, BT[3:0], AP, DSTB, SLP, STB  
	Write_Command_Data(0x0011, 0x0227); // Set DC1[2:0], DC0[2:0], VC[2:0]  
	delay(50); // Delay 5000ms  
	Write_Command_Data(0x0012, 0x000D); // 0012  
	delay(50); // Delay 5000ms  
	Write_Command_Data(0x0013, 0x1200); // VDV[4:0] for VCOM amplitude  
	Write_Command_Data(0x0029, 0x000A); // 04  VCM[5:0] for VCOMH  
	Write_Command_Data(0x002B, 0x000D); // Set Frame Rate  
	delay(50); // Delay 5000ms  
	Write_Command_Data(0x0020, 0x0000); // GRAM horizontal Address  
	Write_Command_Data(0x0021, 0x0000); // GRAM Vertical Address  
	// ----------- Adjust00 the Gamma Curve ----------//  
	Write_Command_Data(0x0030, 0x0000);  
	Write_Command_Data(0x0031, 0x0404);  
	Write_Command_Data(0x0032, 0x0003);  
	Write_Command_Data(0x0035, 0x0405);  
	Write_Command_Data(0x0036, 0x0808);  
	Write_Command_Data(0x0037, 0x0407);  
	Write_Command_Data(0x0038, 0x0303);  
	Write_Command_Data(0x0039, 0x0707);  
	Write_Command_Data(0x003C, 0x0504);  
	Write_Command_Data(0x003D, 0x0808);  
	//------------------ 00Set GRAM area ---------------//  
	Write_Command_Data(0x0050, 0x0000); // Horizontal GRAM Start Address  
	Write_Command_Data(0x0051, 0x00EF); // Horizontal GRAM End Address  
	Write_Command_Data(0x0052, 0x0000); // Vertical GRAM Start Address  
	Write_Command_Data(0x0053, 0x013F); // Vertical GRAM Start Address  
	Write_Command_Data(0x0060, 0xA700); // Gate Scan Line  
	Write_Command_Data(0x0061, 0x0001); // NDL,VLE, REV   
	Write_Command_Data(0x006A, 0x0000); // set scrolling line  
	//-------------- Part00ial Display Control ---------//  
	Write_Command_Data(0x0080, 0x0000);  
	Write_Command_Data(0x0081, 0x0000);  
	Write_Command_Data(0x0082, 0x0000);  
	Write_Command_Data(0x0083, 0x0000);  
	Write_Command_Data(0x0084, 0x0000);  
	Write_Command_Data(0x0085, 0x0000);  
	//-------------- Pane00l Control -------------------//  
	Write_Command_Data(0x0090, 0x0010);  
	Write_Command_Data(0x0092, 0x0000);  
	Write_Command_Data(0x0007, 0x0133);
	}
	
}

void LCDTouch::Touch_Init(void)
{
	orient					= LANDSCAPE ;
	_default_orientation	= CAL_S>>31;
	touch_x_left			= (CAL_X>>14) & 0x3FFF;
	touch_x_right			= CAL_X & 0x3FFF;
	touch_y_top				= (CAL_Y>>14) & 0x3FFF;
	touch_y_bottom			= CAL_Y & 0x3FFF;
	disp_x_size				= (CAL_S>>12) & 0x0FFF;
	disp_y_size				= CAL_S & 0x0FFF;
	prec					= 10;
	
    pinMode(T_CLK,  OUTPUT);
    pinMode(T_CS,   OUTPUT);
    pinMode(T_DIN,  OUTPUT);
    pinMode(T_DOUT, INPUT);
    pinMode(T_IRQ,  INPUT);
	
	digitalWrite(T_CS,  HIGH);	
	digitalWrite(T_CLK, HIGH);
	digitalWrite(T_DIN, HIGH);
	digitalWrite(T_CLK, HIGH);
}

void LCDTouch::Touch_WriteData(unsigned char data)
{
	unsigned char temp;
	unsigned char nop;
	unsigned char count;

	temp=data;
	digitalWrite(T_CLK,LOW);
	for(count=0; count<8; count++)
	{
		if(temp & 0x80)
		{
			digitalWrite(T_DIN, HIGH);
		}
		else
		{	
			digitalWrite(T_DIN, LOW);
		}
		temp = temp << 1; 
		digitalWrite(T_CLK, LOW);
		nop++;
		digitalWrite(T_CLK, HIGH);
		nop++;
	}
}

unsigned int LCDTouch::Touch_ReadData()
{
	unsigned char nop;
	unsigned int data = 0;
	unsigned char count;
	for(count=0; count<12; count++)
	{
		data <<= 1;
		digitalWrite(T_CLK, HIGH);
		nop++;
		digitalWrite(T_CLK, LOW);
		nop++;
		if (digitalRead(T_DOUT))
		 {
			data++;
		 }
	}
	return(data);
}
void LCDTouch::Touch_Read()
{
	unsigned long tx=0, temp_x=0;
	unsigned long ty=0, temp_y=0;
	int datacount=0;

	digitalWrite(T_CS,LOW);                    

	for (int i=0; i<prec; i++)
	{
		Touch_WriteData(0x90);        
		digitalWrite(T_CLK,HIGH);
		digitalWrite(T_CLK,LOW); 
		temp_x=Touch_ReadData();

		Touch_WriteData(0xD0);      
		digitalWrite(T_CLK,HIGH);
		digitalWrite(T_CLK,LOW);
		temp_y=Touch_ReadData();

		if (!((temp_x>max(touch_x_left, touch_x_right)) or (temp_x==0) or (temp_y>max(touch_y_top, touch_y_bottom)) or (temp_y==0)))
		{
			ty+=temp_x;
			tx+=temp_y;
			datacount++;
		}
	}

	digitalWrite(T_CS,HIGH);
	if (datacount>0)
	{
		if (orient == _default_orientation)
		{
			TP_X=tx/datacount;
			TP_Y=ty/datacount;
		}
		else
		{
			TP_X=ty/datacount;
			TP_Y=tx/datacount;
		}
	}
	else
	{
		TP_X=-1;
		TP_Y=-1;
	}
}

char LCDTouch::Touch_DataAvailable()
{
  char avail;
	pinMode(T_IRQ,  INPUT);
	avail = !digitalRead(T_IRQ);
	pinMode(T_IRQ,  OUTPUT);
  return avail;
}
int LCDTouch::Touch_GetX()
{
	long c;

	if (orient == _default_orientation)
	{
		c = long(long(TP_X - touch_x_left) * (disp_x_size)) / long(touch_x_right - touch_x_left);
		if (c<0)
			c = 0;
		if (c>disp_x_size)
			c = disp_x_size;
	}
	else
	{
		if (_default_orientation == PORTRAIT)
			c = long(long(TP_X - touch_y_top) * (-disp_y_size)) / long(touch_y_bottom - touch_y_top) + long(disp_y_size);
		else
			c = long(long(TP_X - touch_y_top) * (disp_y_size)) / long(touch_y_bottom - touch_y_top);
		if (c<0)
			c = 0;
		if (c>disp_y_size)
			c = disp_y_size;
	}
	if(display_model == LCD2_4)
	{
		c = 320/290*c;
	}
	else
	{
	
	}
	return c;
}
int LCDTouch::Touch_GetY()
{
	int c;

	if (orient == _default_orientation)
	{
		c = long(long(TP_Y - touch_y_top) * (disp_y_size)) / long(touch_y_bottom - touch_y_top);
		if (c<0)
			c = 0;
		if (c>disp_y_size)
			c = disp_y_size;
	}
	else
	{
		if (_default_orientation == PORTRAIT)
			c = long(long(TP_Y - touch_x_left) * (disp_x_size)) / long(touch_x_right - touch_x_left);
		else
			c = long(long(TP_Y - touch_x_left) * (-disp_x_size)) / long(touch_x_right - touch_x_left) + long(disp_x_size);
		if (c<0)
			c = 0;
		if (c>disp_x_size)
			c = disp_x_size;
	}
	if(display_model == LCD2_4)
	{
		c = (240/190*c);
	}
	else
	{
		c = (240-c);
	}
	
	return c;
}