/*
本实验实现的功能：
在LCD上面显示一些图形，并统计运行时长
*/
#include <LCDTouch.h>
LCDTouch TouchPPP;  

void setup()
{
  TouchPPP.LCDUTFT(LCD3_2);		//初始化LCDTouch选择3.2inch LCD
  TouchPPP.Lcd_Init();			//屏幕初始化
  TouchPPP.setColor(0xf800);	//设置显示颜色
  TouchPPP.setBackColor(0x07e0);//设置背景颜色
  TouchPPP.setFont(8,12,32);	//设置字体为8x12

  randomSeed(analogRead(0));
}

void loop()
{
  int buf[318];
  int x, x2;
  int y, y2;
  int r;
	
// Clear the screen and draw the frame
  TouchPPP.clrScr();
  TouchPPP.fillScr(0x0000);
  TouchPPP.setColor(255, 0, 0);
  TouchPPP.fillRect(0, 0, 319, 13);
  TouchPPP.setColor(64, 64, 64);
  TouchPPP.fillRect(0, 226, 319, 239);
  TouchPPP.setColor(255, 255, 255);
  TouchPPP.setBackColor(255, 0, 0);
  TouchPPP.print("* Universal Color TFT Display Library *", CENTER,1,0);
  TouchPPP.setBackColor(64, 64, 64);
  TouchPPP.setColor(255,255,0);
  TouchPPP.print("<http://electronics.henningkarlsen.com>", CENTER,227,0);
  TouchPPP.setColor(0, 0, 255);
  TouchPPP.drawRect(0, 14, 319, 225);

// Draw crosshairs
  TouchPPP.setColor(0, 0, 255);
  TouchPPP.setBackColor(0, 0, 0);
  TouchPPP.drawLine(159, 15, 159, 224);
  TouchPPP.drawLine(1, 119, 318, 119);
  for (int i=9; i<310; i+=10)
    TouchPPP.drawLine(i, 117, i, 121);
  for (int i=19; i<220; i+=10)
    TouchPPP.drawLine(157, i, 161, i);

// Draw sin-, cos- and tan-lines  
  TouchPPP.setColor(0,255,255);
  TouchPPP.print("Sin", 5, 15,0);
  for (int i=1; i<318; i++)
  {
    TouchPPP.drawPixel(i,119+(sin(((i*1.13)*3.14)/180)*95));
  }
  
  TouchPPP.setColor(255,0,0);
  TouchPPP.print("Cos", 5, 27,0);
  for (int i=1; i<318; i++)
  {
    TouchPPP.drawPixel(i,119+(cos(((i*1.13)*3.14)/180)*95));
  }

  TouchPPP.setColor(255,255,0);
  TouchPPP.print("Tan", 5, 39,0);
  for (int i=1; i<318; i++)
  {
    TouchPPP.drawPixel(i,119+(tan(((i*1.13)*3.14)/180)));
  }

  delay(2000);

  TouchPPP.setColor(0,0,0);
  TouchPPP.fillRect(1,15,318,224);
  TouchPPP.setColor(0, 0, 255);
  TouchPPP.setBackColor(0, 0, 0);
  TouchPPP.drawLine(159, 15, 159, 224);
  TouchPPP.drawLine(1, 119, 318, 119);

// Draw a moving sinewave
  x=1;
  for (int i=1; i<(318*20); i++) 
  {
    x++;
    if (x==319)
      x=1;
    if (i>319)
    {
      if ((x==159)||(buf[x-1]==119))
        TouchPPP.setColor(0,0,255);
      else
        TouchPPP.setColor(0,0,0);
      TouchPPP.drawPixel(x,buf[x-1]);
    }
    TouchPPP.setColor(0,255,255);
    y=119+(sin(((i*1.1)*3.14)/180)*(90-(i / 100)));
    TouchPPP.drawPixel(x,y);
    buf[x-1]=y;
  }

  delay(2000);
  
  TouchPPP.setColor(0,0,0);
  TouchPPP.fillRect(1,15,318,224);

// Draw some filled rectangles
  for (int i=1; i<6; i++)
  {
    switch (i)
    {
      case 1:
        TouchPPP.setColor(255,0,255);
        break;
      case 2:
        TouchPPP.setColor(255,0,0);
        break;
      case 3:
        TouchPPP.setColor(0,255,0);
        break;
      case 4:
        TouchPPP.setColor(0,0,255);
        break;
      case 5:
        TouchPPP.setColor(255,255,0);
        break;
    }
    TouchPPP.fillRect(70+(i*20), 30+(i*20), 130+(i*20), 90+(i*20));
  }

  delay(2000);
  
  TouchPPP.setColor(0,0,0);
  TouchPPP.fillRect(1,15,318,224);

// Draw some filled, rounded rectangles
  for (int i=1; i<6; i++)
  {
    switch (i)
    {
      case 1:
        TouchPPP.setColor(255,0,255);
        break;
      case 2:
        TouchPPP.setColor(255,0,0);
        break;
      case 3:
        TouchPPP.setColor(0,255,0);
        break;
      case 4:
        TouchPPP.setColor(0,0,255);
        break;
      case 5:
        TouchPPP.setColor(255,255,0);
        break;
    }
    TouchPPP.fillRoundRect(190-(i*20), 30+(i*20), 250-(i*20), 90+(i*20));
  }
  
  delay(2000);
  
  TouchPPP.setColor(0,0,0);
  TouchPPP.fillRect(1,15,318,224);

// Draw some filled circles
  for (int i=1; i<6; i++)
  {
    switch (i)
    {
      case 1:
        TouchPPP.setColor(255,0,255);
        break;
      case 2:
        TouchPPP.setColor(255,0,0);
        break;
      case 3:
        TouchPPP.setColor(0,255,0);
        break;
      case 4:
        TouchPPP.setColor(0,0,255);
        break;
      case 5:
        TouchPPP.setColor(255,255,0);
        break;
    }
    TouchPPP.fillCircle(100+(i*20),60+(i*20), 30);
  }
  
  delay(2000);
  
  TouchPPP.setColor(0,0,0);
  TouchPPP.fillRect(1,15,318,224);

// Draw some lines in a pattern
  TouchPPP.setColor (255,0,0);
  for (int i=15; i<224; i+=5)
  {
    TouchPPP.drawLine(1, i, (i*1.44)-10, 224);
  }
  TouchPPP.setColor (255,0,0);
  for (int i=224; i>15; i-=5)
  {
    TouchPPP.drawLine(318, i, (i*1.44)-11, 15);
  }
  TouchPPP.setColor (0,255,255);
  for (int i=224; i>15; i-=5)
  {
    TouchPPP.drawLine(1, i, 331-(i*1.44), 15);
  }
  TouchPPP.setColor (0,255,255);
  for (int i=15; i<224; i+=5)
  {
    TouchPPP.drawLine(318, i, 330-(i*1.44), 224);
  }
  
  delay(2000);
  
  TouchPPP.setColor(0,0,0);
  TouchPPP.fillRect(1,15,318,224);

// Draw some random circles
  for (int i=0; i<100; i++)
  {
    TouchPPP.setColor(random(255), random(255), random(255));
    x=32+random(256);
    y=45+random(146);
    r=random(30);
    TouchPPP.drawCircle(x, y, r);
  }

  delay(2000);
  
  TouchPPP.setColor(0,0,0);
  TouchPPP.fillRect(1,15,318,224);

// Draw some random rectangles
  for (int i=0; i<100; i++)
  {
    TouchPPP.setColor(random(255), random(255), random(255));
    x=2+random(316);
    y=16+random(207);
    x2=2+random(316);
    y2=16+random(207);
    TouchPPP.drawRect(x, y, x2, y2);
  }

  delay(2000);
  
  TouchPPP.setColor(0,0,0);
  TouchPPP.fillRect(1,15,318,224);

// Draw some random rounded rectangles
  for (int i=0; i<100; i++)
  {
    TouchPPP.setColor(random(255), random(255), random(255));
    x=2+random(316);
    y=16+random(207);
    x2=2+random(316);
    y2=16+random(207);
    TouchPPP.drawRoundRect(x, y, x2, y2);
  }

  delay(2000);
  
  TouchPPP.setColor(0,0,0);
  TouchPPP.fillRect(1,15,318,224);

  for (int i=0; i<100; i++)
  {
    TouchPPP.setColor(random(255), random(255), random(255));
    x=2+random(316);
    y=16+random(209);
    x2=2+random(316);
    y2=16+random(209);
    TouchPPP.drawLine(x, y, x2, y2);
  }

  delay(2000);
  
  TouchPPP.setColor(0,0,0);
  TouchPPP.fillRect(1,15,318,224);

  for (int i=0; i<10000; i++)
  {
    TouchPPP.setColor(random(255), random(255), random(255));
    TouchPPP.drawPixel(2+random(316), 16+random(209));
  }

  delay(2000);

  TouchPPP.fillScr(0, 0, 255);
  TouchPPP.setColor(255, 0, 0);
  TouchPPP.fillRoundRect(80, 70, 239, 169);
  
  TouchPPP.setColor(255, 255, 255);
  TouchPPP.setBackColor(255, 0, 0);
  TouchPPP.print("That's it!", CENTER, 93,0);
  TouchPPP.print("Restarting in a", CENTER, 119,0);
  TouchPPP.print("few seconds...", CENTER, 132,0);
  
  TouchPPP.setColor(0, 255, 0);
  TouchPPP.setBackColor(0, 0, 255);
  TouchPPP.print("Runtime: (msecs)", CENTER, 210,0);
  TouchPPP.printNumI(millis(), CENTER, 225,0,0);
  
  delay (10000);
}

